unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ListBox1: TListBox;
    Button6: TButton;
    Label1: TLabel;
    ListBox2: TListBox;
    Label2: TLabel;
    ListBox3: TListBox;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HWList;
    procedure INFList;
    procedure ListBox2DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SetupAPI;

{$R *.DFM}

function StringsToPCharArray(var Dest: PPSTR; const Source: TStrings): PPSTR;
var
  i: Integer;
  s: string;
  list: array of PChar;
begin
  Dest := AllocMem((Source.Count + 1) * SizeOf(PChar)); // one more for an extra nil pointer
  SetLength(List, Source.Count + 1);
  for i := 0 to Source.Count - 1 do
  begin
    s := Source[i];
    list[i] := StrAlloc(Length(s) + 1);
    StrPCopy(list[i], s);
  end;
  list[Source.Count] := nil;
  Move(list[0], Dest^, (Source.Count + 1) * SizeOf(PChar));
  Result := Dest;
end;

procedure PCharArrayToStrings(const Dest: TStrings; const Source: PPSTR; const Count: Integer);
var
  i: Integer;
  list: array of PChar;
begin
  SetLength(list, Count);
  Move(Source^, list[0], Count * SizeOf(PChar));
  Dest.Clear;
  for i := 0 to Count - 1 do
    Dest.Add(List[i]);
end;

procedure FreePCharArray(var Dest: PPSTR; const Count: Integer);
var
  i: Integer;
  list: array of PChar;
begin
  SetLength(list, Count);
  Move(Dest^, list[0], Count * SizeOf(PChar));
  for i := 0 to Count - 1 do
    StrDispose(list[i]);
  FreeMem(Dest, (Count + 1) * SizeOf(PChar));
  Dest := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  buf: array[0..255] of Char;
  siz: DWORD;
  SourceList: PPSTR;
  Count: DWORD;
  SourceStrings: TStringList;
begin
  SourceStrings := TStringList.Create;
  SetupQuerySourceList(SRCLIST_SYSTEM or SRCLIST_USER or SRCLIST_NOSTRIPPLATFORM, SourceList, Count);
  PCharArrayToStrings(SourceStrings, SourceList, Count);
  SetupFreeSourceList(SourceList, Count);
  SourceStrings.Insert(0, 'L:\this is the added entry');
  StringsToPCharArray(SourceList, SourceStrings);
  SetupSetSourceList(SRCLIST_TEMPORARY, SourceList, SourceStrings.Count);
  SetupPromptForDisk(Handle, 'Prompt for Disk Title', 'Disk Name', 'C:\', 'FileName.tst', nil, 0, buf, 256, siz);
  SetupCancelTemporarySourceList;
  FreePCharArray(SourceList, SourceStrings.Count);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  buf: array[0..255] of Char;
  siz: DWORD;
begin
  SetupCopyError(Handle, 'Copy Error Title', 'Disk Name', 'C:\', 'FileName.tst', nil, 0, 0, buf, 256, @siz);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SetupRenameError(Handle, 'Rename Error Title', 'FileName.tst', 'DestFile.tst', 0, 0);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SetupDeleteError(Handle, 'Delete Error Title', 'FileName.tst', 0, 0);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ShowMessage('not for Windows 98');
   //SetupBackupError(Handle,'Backup Error Title','SourceFile.tst','BackupFile.tst',0,0);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  SetupPromptReboot(nil, Form1.Handle, False);
end;

procedure TForm1.HWList;
var
  hwlist: array[0..31] of DWORD;
  len: DWORD;
  activ: DWORD;
  i: Integer;
  sel: DWORD;
  buf: array[0..127] of Char;
begin
  sel := 0;
  SetupDiGetHwProfileList(@hwlist[0], 32, len, @activ);
  for i := 0 to len - 1 do
  begin
    SetupDiGetHwProfileFriendlyName(hwlist[i], buf, 128, nil);
    ListBox1.Items.Add(Format('%4d %s', [hwlist[i], buf]));
    if hwlist[i] = activ then
      sel := i;
  end;
  ListBox1.ItemIndex := sel;
end;

procedure TForm1.INFList;
var
  len: DWORD;
  buf: PChar;
  p: PChar;
begin
  SetupGetInfFileList(nil, INF_STYLE_WIN4, nil, 0, @len);
  GetMem(buf, len + 1);
  SetupGetInfFileList(nil, INF_STYLE_WIN4, buf, len, nil);
  p := buf;
  while p^ <> Chr(0) do
  begin
    ListBox2.Items.Add(p);
    p := p + strlen(p) + 1;
  end;
  FreeMem(buf);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadSetupApi;
  HWList;
  INFList;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  UnloadSetupApi;
end;

procedure TForm1.ListBox2DblClick(Sender: TObject);
var
  len: DWORD;
  InfInfo: PSPInfInformation;
  buf: PChar;
  p: PChar;
  p2: PChar;
begin
  SetupGetInfInformation(PChar(ListBox2.Items[ListBox2.ItemIndex]), INFINFO_DEFAULT_SEARCH, nil, 0, @len);
  GetMem(InfInfo, len);
  SetupGetInfInformation(PChar(ListBox2.Items[ListBox2.ItemIndex]), INFINFO_DEFAULT_SEARCH, InfInfo, len, nil);
  len := 0;
  SetupQueryInfVersionInformation(InfInfo^, 0, nil, nil, 0, @len);
  GetMem(buf, len);
  SetupQueryInfVersionInformation(InfInfo^, 0, nil, buf, len, nil);
  ListBox3.Clear;
  p := buf;
  while p^ <> Chr(0) do
  begin
    p2 := p + StrLen(p) + 1;
    ListBox3.Items.Add(p + '=' + p2);
    p := p2 + StrLen(p2) + 1;
  end;
  FreeMem(buf);
  FreeMem(InfInfo);
end;

end.

